from turtle import *
from random import randint

"""
Ce fichier est expliqué ici : https://nsi.xyz/py2png
Un autre tutoriel permet de commencer : https://nsi.xyz/tutoriels/decouvrir-le-module-turtle-de-python/
"""

try:
    from PIL import Image
    pillow_installed = True
except:
    print("Oops! - ModuleNotFoundError: No module named 'PIL' - RTFM :")
    print("https://nsi.xyz/py2png")
    pillow_installed = False

# Uniquement des lettres, des chiffres, un tiret. Rien d'autre.
# https://learn.microsoft.com/fr-fr/windows/win32/fileio/naming-a-file
titre = "Spirale - construite avec turtle"

# Définir le titre de la fenêtre de turtle + propagande ^^
title(titre+" | Au lycée, la meilleure spécialité, c'est la spé NSI")

# definir la taille de la fenêtre en 720p (Largeur, Hauteur)
# La tortue part du centre, au point de coordonnées (0,0)
setup(1280, 720)

# La tortue va à la vitesse du lièvre et active sa cape d'invisibilité
speed(0)
hideturtle()

# ============== MON SCRIPT PYTHON ==============


# Affiche un fond bleu nuit

colormode(255)
color(5,9,44)
goto(-640,0)
pensize(1000)
forward(1000)


# Fonction créant une étoile à 5 branches

def etoile():
    pensize(2)
    couleur = randint(0,3)
    if couleur == 0:
        color(250, 137, 25)
    else:
        color(247,247,36)
    for _ in range(5):
        forward(10)
        right(144)
    
    
# Fonction créant une étoile à 4 branches
        
def etoile_2():
    pensize(3)
    color(255,255,255)
    for _ in range(4):
        forward(3)
        backward(3)
        right(90)
    
       
def position_aleatoire():
    penup()
    x = randint(-640,640)
    y = randint(-320,320)
    goto(x,y)
    pendown()
    
    
# Boucle générant à des coordonnées aléatoires les 2 types d'étoiles

for _ in range(42):
    position_aleatoire()
    type_etoile = randint(0,2)
    if type_etoile == 0:
        etoile_2()
    else:
        etoile()
        
# Les 4 fonctions ci-dessous dessinent les différentes partie d'une fusée

def moteur():
    color(80,80,80)
    begin_fill()
    fillcolor(80,80,80)
    pensize(5)
    for _ in range(2):
        forward(50)
        right(90)
        forward(20)
        right(90)
    end_fill()
    
def corps_fusee():
    color(140,140,140)
    begin_fill()
    fillcolor(140,140,140)
    for _ in range(2):
        forward(200)
        right(90)
        forward(80)
        right(90)
    end_fill()
    
def hublot():
    pensize(1)
    color("black")
    begin_fill()
    fillcolor(255,255,255)
    for _ in range(16):
        forward(10)
        left(45/2)
    end_fill()
    
def toit():
    color("red")
    begin_fill()
    fillcolor("red")
    for _ in range(3):
        forward(80)
        right(120)
    end_fill()


def fusee():
    left(55)
    penup()
    goto(-100,-40)
    pendown()
    corps_fusee()
    for i in range(2):
        penup()
        goto(-125+i*275/100*25,-50-i*5/2*20)
        pendown()
        moteur()
    for i in range(2):
        penup()
        goto(-15+i*35*135/100,-65/2+i*50*135/100)
        pendown()
        hublot()
    right(30)
    penup()
    goto(15,125)
    pendown()
    toit()
      
fusee()

# Boucle générant la base de la comète

penup()
goto(255,-120)
pendown()
color(77,51,17)
fillcolor(77,51,17)
cote=7
begin_fill()
for k in range(cote) :
    forward(30)
    left(360/cote)
end_fill()

# Fonction créant une étincelle

def etincelle():
    pensize(6)
    couleur = randint(0,2)
    if couleur == 0:
        color(250, 137, 25) #orange
    else:
        color(235,160,27)   #orange clair
    for _ in range(5):
        forward(10)
        right(1440)
    
# Fonction créant une deuxieme type d'étincelle
        
def etincelle2():
    pensize(5)
    couleur = randint(0,2)
    if couleur == 0:
        color(235,218,27)  #jaune
    else:
        color(225,200,3)   #jaune foncé
    for _ in range(5):
        forward(10)
        right(144)

# Fonction créant une troisieme type d'étincelle

def etincelle3():
    pensize(5)
    couleur = randint(0,2)
    if couleur == 0:
        color(225,36,3)  #rouge
    else:
        color(225,80,3)  #orange foncé
    for _ in range(5):
        forward(10)
        right(1440)


def position_aleatoire2():
    penup()
    x = randint(250,320)
    y = randint(-100,-50)
    goto(x,y)
    pendown()
    
def position_aleatoire3():
    penup()
    x = randint(300,360)
    y = randint(-80,-15)
    goto(x,y)
    pendown() 

def position_aleatoire4():
    penup()
    x = randint(350,400)
    y = randint(-65,15)
    goto(x,y)
    pendown()

# Boucle générant à des coordonnées aléatoires les 2 types d'étincelle

for _ in range(30):
    position_aleatoire2()
    type_etincelle = randint(0,10)
    
    if type_etincelle < 4:
        etincelle()
    elif type_etincelle > 5:
        etincelle3()
    else:
        etincelle2()

for _ in range(20):
    position_aleatoire3()
    type_etincelle = randint(0,10)
    
    if type_etincelle < 3:
        etincelle()
    elif type_etincelle > 4:
        etincelle3()
    else:
        etincelle2()

for _ in range(10):
    position_aleatoire4()
    type_etincelle = randint(0,10)
    
    if type_etincelle < 3:
        etincelle()
    elif type_etincelle > 3:
        etincelle3()
    else:
        etincelle2()

def cratere():
    color(168,46,103)
    pensize(10)
    begin_fill()
    fillcolor(168,46,103)
    circle(20)
    end_fill()

# fonction générant la planète

def planete():
    pensize(1820)
    color(209, 143, 193)
    begin_fill()
    fillcolor(209, 143, 193)
    for _ in range(16):
        forward(10)
        left(45/2)
    end_fill()
    
penup()
goto(-620,-1100)
pendown()
planete()
penup()
goto(-300,-300)
pendown()
cratere()
penup()
goto(-575,-250)
pendown()
cratere()

# ============== GENERER DES IMAGES AUTOMATIQUEMENT ==============

image = getcanvas()
nom_du_fichier_sans_extension=titre+"_"+hex(randint(2**30+2**25,2**30+2**25+2**24-1))[2:]

# Génère un fichier .ps
image.postscript(file=nom_du_fichier_sans_extension+".ps", colormode='color')

# Ouvre le fichier .ps et génère le fichier .png


try:
    psimage = Image.open(nom_du_fichier_sans_extension+".ps")
    psimage.load(scale=2)
    psimage_resized = psimage.resize((1280, 720))
    psimage.save(nom_du_fichier_sans_extension+".png")
    print(nom_du_fichier_sans_extension+".png", psimage.size, "sauvegardé dans le dossier")    
    
except:
    if not pillow_installed:
        print("Oops! - ModuleNotFoundError: No module named 'PIL' - RTFM :")
        print("https://nsi.xyz/py2png")
    else:
        print("Oops! - 'ghostscript' not installed- RTFM :")
        print("https://nsi.xyz/py2png")

exitonclick()
